package kr.co.vividnext.sodalive.useraction

import kr.co.vividnext.sodalive.common.ApiResponse
import kr.co.vividnext.sodalive.common.SodaException
import kr.co.vividnext.sodalive.member.Member
import org.springframework.security.core.annotation.AuthenticationPrincipal
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@RequestMapping("/user-action")
class UserActionController(private val service: UserActionService) {
    @PostMapping
    fun recordAction(
        @RequestBody request: UserActionRequest,
        @AuthenticationPrincipal(expression = "#this == 'anonymousUser' ? null : member") member: Member?
    ) = run {
        if (member == null) throw SodaException("")

        service.recordAction(
            memberId = member.id!!,
            isAuth = member.auth != null,
            actionType = request.actionType
        )

        ApiResponse.ok(Unit, "")
    }
}
